#extends RigidBody
#
#export var motor_force = 2.0
#export var motor_force_boost = 4.0
#export var rotation_force = 0.4
#export var rotation_spring = 4.0
#
#func _ready():
#	gravity_scale=0
#
#onready var linear_velocity_before = linear_velocity
#onready var angular_velocity_before = angular_velocity
#
#func _physics_process(delta):
#	var linear_acc  = (linear_velocity  - linear_velocity_before) / delta
#	var angular_acc = (angular_velocity - angular_velocity_before) / delta
#	linear_velocity_before  = linear_velocity
#	angular_velocity_before = angular_velocity
#
#	var direction = Vector3.ZERO
#	direction+= Input.get_axis("move_a", "move_d")*global_transform.basis.x
#	direction+= Input.get_axis("move_w", "move_s")*global_transform.basis.z
#	direction = direction.normalized()
#	var boost = 1.0
#	if Input.is_action_pressed("boost"): boost=motor_force_boost
#	apply_central_impulse(Vector3(direction.x,Input.get_axis("move_k", "move_i")+Input.get_axis("move_q", "move_e"),direction.z)*motor_force*boost)
#	# apply_central_impulse(-0.02*linear_velocity*motor_force*delta)
#	#if direction.x!=0 and direction.y!=0:
#	#	linear_damp = 0.4
#	#else:linear_damp = 2
#	linear_damp = 1 + 0.01 * linear_velocity.length()
#	apply_torque_impulse(Vector3.DOWN*rotation_force*Input.get_axis("move_j", "move_l"))
#	# apply_torque_impulse( (.01+.005*boost)*global_transform.basis.x*Input.get_axis("move_w", "move_s"))
#	apply_torque_impulse(global_transform.basis.x*(0.005*boost*Input.get_axis("move_w", "move_s")+0.0002*linear_acc.dot(global_transform.basis.z)))
#	apply_torque_impulse( 0.02*(.1+.3*boost)*global_transform.basis.z*Input.get_axis("move_d", "move_a"))
#	apply_torque_impulse( 0.1 *(.1+.3*boost)*global_transform.basis.z*Input.get_axis("move_l", "move_j"))
#	apply_torque_impulse(1.6*global_transform.basis.x* global_transform.basis.z.dot(Vector3.UP))
#	apply_torque_impulse(1.3*global_transform.basis.z* global_transform.basis.x.dot(Vector3.DOWN))
#
#	angular_damp = 3
#	# friction
#	# mass
#	# apply_impulse(position: Vector3, impulse: Vector3)
#	$campos/camera.rotation.x = lerp($campos/camera.rotation.x,-.6*Input.get_axis("move_o", "move_u"),0.2)
#	if Input.is_action_pressed("move_u"):
#		$campos/camera.translation.z = lerp($campos/camera.translation.z,-.9,0.1)
#		$campos/camera.translation.y = lerp($campos/camera.translation.y, .6,0.15)
#	else:
#		$campos/camera.translation.z = lerp($campos/camera.translation.z,0,0.1)
#		$campos/camera.translation.y = lerp($campos/camera.translation.y,0,0.15)
#	#else:
#
#	# angular_velocity -= Vector3(rotation.x,0,rotation.z)*delta*rotation_spring
#	# angular_velocity -= Vector3.UP*delta*rotation_force*direction_r
#	# apply_impulse(Vector3.ZERO, -Vector3.UP*rotation_force*direction_r)
#	# apply_impulse(Vector3.ZERO, -Vector3(rotation.x,0,rotation.z)*delta*rotation_spring)
#
#	# angular_velocity = lerp(angular_velocity,Vector3.ZERO,0.1)
#	# if Input.is_action_pressed("move_w") or Input.is_action_pressed("move_a") or Input.is_action_pressed("move_s") or Input.is_action_pressed("move_d"):
#	# 	linear_velocity = lerp(linear_velocity,Vector3.ZERO,0.02)
#	# else: linear_velocity = lerp(linear_velocity,Vector3.ZERO,0.05)

extends RigidBody

export var motor_force = 2.0
export var motor_force_boost = 4.0
export var rotation_force = 1.0
export var rotation_spring = 4.0

func _ready():
#	Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
	gravity_scale=0

var _mouse_motion = Vector2.ZERO
#func _input(event):
#	if event is InputEventMouseMotion:
#		if Input.get_mouse_mode() == Input.MOUSE_MODE_CAPTURED:
#			_mouse_motion += event.relative

var linear_velocity_before = linear_velocity
var angular_velocity_before = angular_velocity
func _physics_process(delta):
	var linear_acc  = (linear_velocity  - linear_velocity_before) / delta
	var angular_acc = (angular_velocity - angular_velocity_before) / delta
	linear_velocity_before  = linear_velocity
	angular_velocity_before = angular_velocity
	var direction = Vector3.ZERO
	direction+= Input.get_axis("move_a", "move_d")*global_transform.basis.x
	direction+= Input.get_axis("move_w", "move_s")*global_transform.basis.z
	direction = direction.normalized()
	var boost = 1.0
	if Input.is_action_pressed("boost"): boost=motor_force_boost
	apply_central_impulse(Vector3(direction.x,Input.get_axis("move_i", "move_k")+Input.get_axis("move_q", "move_e"),direction.z)*motor_force*boost)
	linear_damp = 1 + 0.01 * linear_velocity.length()
	apply_torque_impulse(Vector3.DOWN*rotation_force*Input.get_axis("move_j", "move_l"))
	apply_torque_impulse(4.0*global_transform.basis.x*(0.005*boost*Input.get_axis("move_w", "move_s")+0.0002*linear_acc.dot(global_transform.basis.z)))
	apply_torque_impulse(4.0*0.02*(.1+.3*boost)*global_transform.basis.z*Input.get_axis("move_d", "move_a"))
	apply_torque_impulse(2.0*0.1 *(.1+.3*boost)*global_transform.basis.z*Input.get_axis("move_l", "move_j"))
	var v = Input.get_axis("move_i", "move_k")#+Input.get_axis("move_q", "move_e")
	if v<0:
		apply_central_impulse(10.0*Vector3(0,v,0))
		apply_torque_impulse(4.5*v*global_transform.basis.x*(global_transform.basis.y.dot(Vector3.UP)))
	else:
		apply_torque_impulse(3.2*global_transform.basis.x* global_transform.basis.z.dot(Vector3.UP))
	apply_torque_impulse(2.6*global_transform.basis.z* global_transform.basis.x.dot(Vector3.DOWN))

	angular_damp = 3
#	var trans_z = -0.9*(abs(clamp(4*$campos/camera.rotation.x,-1,0))+int(Input.is_action_pressed("move_u")))
#	var trans_y =  0.6*(abs(clamp(4*$campos/camera.rotation.x,-1,0))+int(Input.is_action_pressed("move_u")))
	var trans_z = -0.9*(abs(clamp(4*$campos/camera.rotation.x,-1,0)))
	var trans_y =  0.6*(abs(clamp(4*$campos/camera.rotation.x,-1,0)))
	$campos/camera.translation.z = lerp($campos/camera.translation.z,trans_z,0.1)
	$campos/camera.translation.y = lerp($campos/camera.translation.y,trans_y,0.15)
	$campos/camera.rotation.y -= 0.2*delta*_mouse_motion.x
	$campos/camera.rotation.x -= 0.2*delta*_mouse_motion.y
	$campos/camera.rotation.x = lerp($campos/camera.rotation.x,-.6*Input.get_axis("move_o", "move_u"),0.1)
#	$campos/camera.rotation.x = lerp($campos/camera.rotation.x,-.6*Input.get_axis("move_o", "move_u"),0.2)
	$campos/camera.rotation.y = lerp($campos/camera.rotation.y,0                                     ,0.1)
	$campos/camera.rotation.z = lerp($campos/camera.rotation.x,0                                     ,0.1)
	$campos/camera.rotation.x = clamp($campos/camera.rotation.x,-.6,PI)
	_mouse_motion = Vector2.ZERO
	
	#$campos.rotation += 0.8*angular_acc*delta # TODO transformer en coord locales
	#$campos.rotation.x = lerp($campos.rotation.x, 0, 0.2)
	#$campos.rotation.y = lerp($campos.rotation.y, 0, 0.2)
	#$campos.rotation.z = lerp($campos.rotation.x, 0, 0.2)
	#$campos.translation += 0.8*linear_acc*delta
	#$campos.translation.x = lerp($campos.translation.x, -0.578, 0.2)
	#$campos.translation.y = lerp($campos.translation.y,  1.308, 0.2)
	#$campos.translation.z = lerp($campos.translation.x, -0.596, 0.2)

